<script lang="ts">
	import { collection, getDocs } from 'firebase/firestore';
	import type { Horaire, Marche, Place } from '../../routes/(admin)/admin/metrouver/type';
	import ServiceItemDropdown from './ServiceItemDropdown.svelte';
	import { db } from '$lib/firebase/firebase';
	import { onMount } from 'svelte';

	let horaires: Horaire[] = [];
	let horairesMap: Map<string, Horaire[]> = new Map();

	const getHoraires = async () => {
		horaires = [];
		const docRef = await getDocs(collection(db, 'horaires'));
		docRef.forEach((doc) => {
			const data = { ...doc.data(), id: doc.id } as Horaire;
			horaires.push(data);
			const horaire = horairesMap.get(data.horaireFrom + '-' + data.horaireTo);
			horairesMap.set(
				data.horaireFrom + '-' + data.horaireTo,
				horaire ? [...horaire, data] : [data]
			);
		});
		horaires = horaires;
		horairesMap = horairesMap;
	};

	let marches: Place[] = [];
	const getMarches = async () => {
		marches = [];
		const docRef = await getDocs(collection(db, 'places'));
		docRef.forEach((doc) => {
			marches.push({ ...doc.data(), id: doc.id } as Place);
		});
		marches = marches;
	};

	onMount(() => {
		getHoraires();
		getMarches();
	});
</script>

<section style="background-color: #333333;" class="text-white h-fit w-full p-8">
	<div class="text-3xl font-title mb-4 text-center">Mes services</div>

	<ul
		class="relative flex flex-col md:flex-row gap-4 justify-around text-lg border-t border-primary-500 p-4 list-disc"
	>
		<ServiceItemDropdown title="Sur place">
			<p>
				{#if horaires.length >= 1}
					{#each Array.from(horairesMap) as [key, value], index}
						Tous les
						{#each value as horaire, i}
							{horaire.jour.toLowerCase()}s{#if i < value.length - 1},&nbsp;{/if}
						{/each}
						de {key.split('-')[0]} à {key.split(
							'-'
						)[1]}{#if index < Array.from(horairesMap).length - 1}
							,&nbsp;
						{/if}
					{/each}
				{/if}
				(sauf jours de marché)
			</p>
		</ServiceItemDropdown>
		<ServiceItemDropdown title="À l'extérieur">
			<ul class="flex flex-col gap-2 text-start">
				{#each marches as marche}
					<li class="text-center">
						- {marche.text}
					</li>
				{/each}
			</ul>
		</ServiceItemDropdown>
		<ServiceItemDropdown title="Pour évenements">
			<p>Veuillez me contacter pour plus d'informations.</p>
		</ServiceItemDropdown>
		<ServiceItemDropdown title="Livrable">
			<p>Livraison possible sous réserve de montant suffisant.</p>
		</ServiceItemDropdown>
	</ul>
</section>
